<?php

namespace App\Http\Controllers\Admin;

use Alert;
use Crypt;
use App\Http\Controllers\Controller;
use App\Repositories\Admin\MsBidangKepakaranKategoriRepository;
use App\Repositories\Admin\MsBidangKepakaranRepository;
use Illuminate\Http\Request;

class BidangKepakaranController extends Controller
{
    private $bidangkepakaranRepo;
    private $bidangkepakarankategoriRepo;

    public function __construct(
        MsBidangKepakaranKategoriRepository $bidangkepakarankategoriRepo,
        MsBidangKepakaranRepository $bidangkepakaranRepo
    ) {
        $this->bidangkepakaranRepo = $bidangkepakaranRepo;
        $this->bidangkepakarankategoriRepo = $bidangkepakarankategoriRepo;
    }

    public function index()
    {
        //
        $menu = 'bidangkepakaran';
        $bidangkepakaran = $this->bidangkepakaranRepo->get(['rKategori']);
        $bidangkepakarankategori = $this->bidangkepakarankategoriRepo->get();
        //dd($bidangkepakarankategori);
        $data = [
            'bidangkepakaran' => $bidangkepakaran,
            'bidangkepakarankategori' => $bidangkepakarankategori,
            'menu' => $menu
        ];

        return view('admin.bidang.index', $data);
    }

    public function bidangkategori()
    {
        //
        $menu = 'bidangkepakaran';
        $bidangkepakarankategori = $this->bidangkepakarankategoriRepo->get();
        //dd($bidangkepakarankategori);
        $data = [
            'bidangkepakarankategori' => $bidangkepakarankategori,
            'menu' => $menu
        ];

        return view('admin.bidang.kategori', $data);
    }


    public function create()
    {
        //
        return view('admin.bidangkepakaran.create');
    }


    public function store(Request $request)
    {
        //
        $data = $request->except('_token');
        $data['user_id'] = auth()->user()->id;
        $bidangkepakaran = $this->bidangkepakaranRepo->store($data);

        $data = [
            'bidangkepakaran' => $bidangkepakaran->id,
        ];

        Alert::success('Berhasil', 'bidangkepakaran berhasil disimpan');

        return redirect()->route('admin.bidangkepakaran.index', $data);
    }

    public function kategoristore(Request $request)
    {
        //
        $data = $request->except('_token');
        $data['user_id'] = auth()->user()->id;
        $bidangkepakarankategori = $this->bidangkepakarankategoriRepo->store($data);

        $data = [
            'bidangkepakarankategori' => $bidangkepakarankategori->id,
        ];

        Alert::success('Berhasil', 'Kategori Bidang kepakaran berhasil disimpan');

        return redirect()->route('admin.bidang.kategori', $data);
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        //
        $menu = 'bidangkepakaran';
        $bidangkepakaran = $this->bidangkepakaranRepo->findId(null, $id);

        $data = [

            'menu' => $menu,
            'bidangkepakaran' => $bidangkepakaran,
        ];

        return view('admin.bidang.edit', $data);
    }

    public function kategoriedit($id)
    {
        //
        $menu = 'bidangkepakarankategori';
        $bidangkepakarankategori = $this->bidangkepakarankategoriRepo->findId(null, $id);

        $data = [

            'menu' => $menu,
            'bidangkepakarankategori' => $bidangkepakarankategori,
        ];

        return view('admin.bidang.edit', $data);
    }


    public function update(Request $request, $id)
    {
        //
        $data = $request->except('_token');
        $data['userid_updated'] = auth()->user()->id;
        $bidangkepakaran = $this->bidangkepakaranRepo->findId(null, $id);
        $this->bidangkepakaranRepo->update($data, $bidangkepakaran);

        $data = [
            'bidangkepakaran' => $bidangkepakaran->id,
        ];

        Alert::success('Berhasil', 'bidangkepakaran berhasil diupdated');

        return redirect()->route('bidang.index', $data);
    }

    public function kategoriupdate(Request $request, $id)
    {
        //
        $data = $request->except('_token');
        $data['userid_updated'] = auth()->user()->id;
        $bidangkepakarankategori = $this->bidangkepakarankategoriRepo->findId(null, $id);
        $this->bidangkepakarankategoriRepo->update($data, $bidangkepakarankategori);

        $data = [
            'bidangkepakarankategori' => $bidangkepakarankategori->id,
        ];

        Alert::success('Berhasil', 'bidangkepakarankategori berhasil diupdated');

        return redirect()->route('bidang.index', $data);
    }


    public function destroy($id)
    {
        //
        $model = $this->bidangkepakaranRepo->findId(null, Crypt::decrypt($id));
        $this->bidangkepakaranRepo->destroy($model);

        Alert::success('Data berhasil dihapus')->persistent('Ok');

        return redirect()->route('bidang.index');
    }
}
